<?php

	/* -------------------------------------------------------------------------
	----------------------------------------------------------------------------
	
						Progress Bar [Server]
						
	----------------------------------------------------------------------------					
	-------------------------------------------------------------------------- */

	require_once("../Util/Constant.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Control/Control.php" );
	
	class ProgressBarServer extends Control
	{
		var $MessageFromServer = '';
		var $SubmitParameters = ''; /* Preserves Query String and re-use it, when re-submitting to itself */
		var $Interval = 2;

		var $CurrentProgress = 0;

		function ProgressBarServer($name, $parent)
		{
			parent::Control($name, $parent);
		}

		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//

		function OnRender()
		{
			$this->SubmitParameters = $_SERVER['QUERY_STRING'];
			
			?>			

			<?php
				// Bug Fix - Very important to avoid error, when accessing on remote machine
				// sleep($this->Interval);

				// SUPERSEDES ! Now same functionality of time interval (above) is performed by javascript on client
			?>
			
			<!-- -------------------------------------------------------------------------------
			------------------------------------------------------------------------------------
			MESSAGE TO CLIENT - All the code below that is html and javascript, is actuall a 
					message from server to client. This code is executed on client side 
			------------------------------------------------------------------------------------					
			------------------------------------------------------------------------------- -->

			<form name="formHttpRPC<?php $this->Mangle();?>" method="POST" action="<?php print($_SERVER['PHP_SELF']) ?>?<?php /* BUG FIX */ print ( $this->SubmitParameters ); ?>" >
			</form>
			
			<script language="javascript">
				
				function ReSubmit<?php $this->Mangle()?>()
				{		
						//
						//		Data Exchange from Server to the Client
						//
						
						// window.parent.divMessageFromServer<?php $this->Mangle()?>.innerHTML = "<?php print( $this->MessageFromServer ); ?>"; // NOTE : Don't Remove, for historical reasons. BUG FIX :  only works in IE. The code below works in IE and Mozilla
						window.parent.document.getElementById ( 'divMessageFromServer<?php $this->Mangle()?>' ).innerHTML = "<?php print( $this->MessageFromServer ); ?>"; // NOTE - Works in both - IE and Mozilla
						window.parent.pb<?php $this->Mangle();?>.SetProgress(<?php print($this->CurrentProgress); ?>);
						
						if ( window.parent.pb<?php $this->Mangle();?>.GetProgress() < 100 )
						{	
							// Continuation Condition
							document.formHttpRPC<?php $this->Mangle();?>.submit(); /* Resubmit to self */
						}
						else
						
						{	// Termination Condition
							clearInterval ( timerID<?php $this->Mangle()?> );
						}
				}
				
				timerID<?php $this->Mangle()?> = setInterval ("ReSubmit<?php $this->Mangle()?>()", <?php print( $this->Interval*500 ) ?> );
				
			</script>
			
			<!-- ----------------------- End of client code ----------------------------------->
			
			<?php
		}
	}
?>

<?php

	/* -------------------------------------------------------------------------
	----------------------------------------------------------------------------
	
						Progress Bar [Client]
	
	----------------------------------------------------------------------------					
	-------------------------------------------------------------------------- */
	
	require_once( "../Util/Constant.php" );
	require_once( CONST_DIR_DATA_PROTECTION()."/Control/Control.php" );
	require_once( CONST_DIR_DATA_PROTECTION()."/Control/ProgressBar.js" );

	class ProgressBarClient extends Control
	{
		var $Title = '';
		var $ServerURL = '';
		var $MessageFromClient = '';
		
		function ProgressBarClient($name, $parent, $serverUrl)
		{
			parent::Control($name, $parent);
			$this->ServerURL = $serverUrl;
		}
		
		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		
		function OnRender()
		{
			?>
			<!-- 
				It would be very nice, that divs are generated from javascript itself,
				but this is a low priority for now - Imran Salim 
			-->
			<div id="divProgressBar<?php $this->Mangle()?>" class="styleProgressBar">
				<div id="divTitle<?php $this->Mangle()?>" class="styleProgressTitle">Title</div>
				<div id="divProgressFrame<?php $this->Mangle()?>" class="styleProgressFrame">
					<div id="divProgressBlock<?php $this->Mangle()?>" class="styleProgressBlock">
						<div id="divProgressNumber<?php $this->Mangle()?>" class="styleProgressNumber"></div>								
					</div>
				</div>
				<br/> <!-- This BR is important, otherwise the next div is printed behind the bar -->
				<div id="divMessageFromServer<?php $this->Mangle()?>" align="right">
				</div>
				<div id="divMessageFromClient<?php $this->Mangle()?>" align="right">
				</div>
				<?php if ( $this->MessageFromClient != '' )
					{
						// Set MessageFromClient's Div's height to 0
					} 
				?>
			</div>
			<!-- ----------------------------------------------
						Remote Scripting 
			------------------------------------------------ -->		
			<?php 
				if ( $this->ServerURL == null || $this->ServerURL == "" )
					print ( "Error : ".$this->FullName()." - Missing ServerURL" );
			?>

			<!-- MESSAGE RECEIVER FROM CLIENT - This code received message from client -->
			<!-- The code in iframe loads, and resubmits after sleeping for a small time. As soon 
			as the code is loaded, it call backs functions on client side, this causing the effoct
			of server calling function on client. This process continues until end condition is reached.
			-->
			<iframe id="frmDownloadStatus_<?php $this->Mangle(); ?>" src="<?php print ($this->ServerURL) ?>"  scrolling=no frameborder=no height=0 width=0>
				<!-- To see the code that is placed in this frame, please look at Server's php file -->
			</iframe>

			<!-- 
				To print anything after divs defined above 
			-->
			<div id=divDebug<?php $this->Mangle(); ?>>
			</div>

			<script language="javascript">
				
				var  pb<?php $this->Mangle(); ?> = new ProgressBar();
				
				divTitle<?php $this->Mangle()?>.innerHTML = "<?php print( $this->Title ); ?>";
				
				pb<?php $this->Mangle(); ?>.InstanceName = "pb<?php $this->Mangle(); ?>";
				pb<?php $this->Mangle(); ?>.DivProgressBlock = divProgressBlock<?php $this->Mangle(); ?>;
				pb<?php $this->Mangle(); ?>.DivProgressNumber = divProgressNumber<?php $this->Mangle(); ?>; 
				ProgressStart ( pb<?php $this->Mangle(); ?> );
				
				divMessageFromClient<?php $this->Mangle()?>.innerText = "<?php print( $this->MessageFromClient ); ?>";
				
			</script>
			
			<?php
		}
	}
?>